//A set of functions to join iinc system to the root
//Last version:20/04/2018 

#include "stdio.h"
#include "iincFu.h"
#include "TFile.h"
#include "TNtuple.h"

void arrayTOntfile (double* ARR, long events, long vars, char* ntuplefilename, char* ntuplename,char* ntheading,
	char* featureslist){
//reads a text file and generates root ntuple 
// FileName - the name of the textfile that contains a matrix of constant number of reals on each row.
// ntuplefilename, e.g. "my_ntuple", ntuplename, e.g. "conf_data", ntheading, e.g. xample N-Tuple",
// featureslist, e.g. "Potential:Current:Temperature:Pressure:Class" 
//   - characteristics of the n-tuple generated
// The file of the same name will be rewritten.8888

	long event,j;
	 //"my_ntuple" is any internal name .. never appears outside the function
	TNtuple my_ntuple(ntuplename,//"cond_data",/88//=ntuplename; 
                      ntheading,//"Example N-Tuple",
                      featureslist//"Potential:Current:Temperature:Pressure:Class"
			);

	// Fill it with the acquired data
	Float_t* arr = new Float_t [vars];//a line, i.e. a set of variables, for one event ///pot,cur,temp,pres;
	for (event=0;event<events;event++){
		for(j=0;j<vars;j++){
			arr[j]=ARR[vars*event+j];
		}
		// write to ntuple
	        my_ntuple.Fill(arr);///zcela obecne; zapise celou strukturu, zde jednorozm. pole
        }
	// Open a file, save the ntuple and close the file
	TFile ofile(ntuplefilename,"RECREATE");//"RECREATE"means build a new or overwrite existing file of the same name.
	my_ntuple.Write();
	ofile.Close();
}

void txtfileTOntfile (char* FileName, char* ntuplefilename, char* ntuplename,char* ntheading,
	char* featureslist){
//reads a text file and generates root ntuple 
// FileName - the name of the textfile that contains a matrix of constant number of reals on each row.
// ntuplefilename, e.g. "my_ntuple", ntuplename, e.g. "conf_data", ntheading, e.g. xample N-Tuple",
// featureslist, e.g. "Potential:Current:Temperature:Pressure:Class" 
//   - characteristics of the n-tuple generated
// The file of the same name will be rewritten.

	long vars, events,i,j;
	double a[10010];
	FILE *ff;
	// Initialise the TNtuple
	 //"my_ntuple" is any internal name .. never appears outside the function
	TNtuple my_ntuple(ntuplename,//"cond_data",///=ntuplename; 
                      ntheading,//"Example N-Tuple",
                      featureslist//"Potential:Current:Temperature:Pressure:Class"
			);

	//open text file
	if((ff=fopen(FileName, "rt"))==NULL){
		printf("Cannot open file to read.\n");
		exit(1);
	}
	vars=CtiRadek(ff,a);//to know the number of features
	// Fill it with the acquired data
	Float_t* arr = new Float_t [vars];//a line, i.e. a set of variables, for one event ///pot,cur,temp,pres;
	rewind(ff);//start anew
	events=0;
	for (;;){
		i=CtiRadek(ff,a);
		for(j=0;j<vars;j++){
			arr[j]=a[j];
		}
		// write to ntuple
	        my_ntuple.Fill(arr);///zcela obecne; zapise celou strukturu, zde jednorozm. pole
		events++;
		if(feof(ff)) break;
        }
	// Open a file, save the ntuple and close the file
	TFile ofile(ntuplefilename,"RECREATE");//"RECREATE"means build a new or overwrite existing file of the same name.
	my_ntuple.Write();
	ofile.Close();
}


void ntfileTOtxtfile(char *ntuplefilename, char* ntuplename, 
	char* txtfilename){
// Read the previously produced N-Tuple and print on screen its content
// Set the file name and the name of the ntuple (eg. of the learninfg or testing set) as parameters,
// This function finds the number of rows and columns
// and saves data into array ARR (double) of the same size.
	long i, irow, lrows;
	int nn;
	FILE *hh;
	// Open a file, read the ntuple and close the file
	TFile in_file(ntuplefilename);
	TNtuple* my_tuple = (TNtuple*) in_file.GetObjectChecked(
                                   ntuplename,///"cond_data"
                                   "inNtuple");   
	nn =my_tuple->GetNvar();
	lrows = my_tuple->GetEntries();
	double* ARR = new double [nn*lrows];
	Float_t* row_content = new Float_t[nn];
	for (irow=0;irow<lrows;++irow){ 
    		my_tuple->GetEntry(irow);
    		row_content = my_tuple->GetArgs();
    		for(i=0; i<nn; i++) {
    			ARR[nn*irow+i] = row_content[i];//uklada se po radcich
    		}
	}
//write array to file ""txtfilename""\n");
	if((hh=fopen(txtfilename, "wt")) == NULL){
		printf("procedure ntfileTOtxtfile: cannot open file to write.\n");
		exit (1);
	}
 	for (irow=0;irow<lrows;++irow){ 
	 	for(i=0; i<nn; i++) {
	    	    	fprintf(hh,"%lg\t", ARR[nn*irow+i]);
//	    	    	printf("%lg\t", ARR[nn*irow+i]);
    		}
    		fprintf(hh,"\n");
//    		printf("\n");
	}
	fclose(hh);
}

void findntarraysize(char *ntuplefilename, char *ntuplename, long *rows, long *cols){
// Read the previously produced N-Tuple and read no of rows and columns
// Given the file name and the name of the ntuple (e.g. of the learninf or testing set) as parameters,
// It finds the number of rows and columns.
	// Open a file, read the ntuple and close the file  %s  %s\n",ntuplefilename,ntuplename);
	TFile in_file(ntuplefilename);
	TNtuple* my_tuple = (TNtuple*) in_file.GetObjectChecked(
		ntuplename,///"cond_data"
		"inNtuple");   
	cols[0] = my_tuple->GetNvar();
	rows[0] = my_tuple->GetEntries();
}


void ntfileTOarray(char *ntuplefilename, char* ntuplename, 
	double* ARR, long arows, long acols){
// Read the previously produced N-Tuple and print to the array.
// Set the file name and the name of the ntuple (eg. of the learning or testing set) as parameters,
// This function supposes known number of rows and columns
// and saves data into array ARR (double) of the same size.
	long i, irow, lrows;
	int nn;
	TFile in_file(ntuplefilename);
	TNtuple* my_tuple = (TNtuple*) in_file.GetObjectChecked(
                                   ntuplename, "inNtuple");   
	nn =my_tuple->GetNvar();
	lrows = my_tuple->GetEntries();
	if(nn!=acols) {
		printf("Bad number of columns!\n");
		exit (1);
	}
	if(lrows>arows){
		printf("Data will be truncated from %li to %li rows.\n", lrows, arows);
		lrows=arows;
	}
	if(lrows<arows) {
		printf("A part of array wil be empty!\n");
	}
	Float_t* row_content = new Float_t[nn];
	for (irow=0;irow<lrows;++irow){ 
    		my_tuple->GetEntry(irow);
    		row_content = my_tuple->GetArgs();
    		for(i=0; i<nn; i++) {
    			ARR[nn*irow+i] = row_content[i];
    		}
	}
}



void ntfileTOscreen(char *ntuplefilename, char* ntuplename){
// Read the previously produced N-Tuple and print to the screen
// the file name and the name of the ntuple and then first max. 10 rows,
	long i, irow, lrows;
	int nn;
	TFile in_file(ntuplefilename);
	TNtuple* my_tuple = (TNtuple*) in_file.GetObjectChecked(
                                   ntuplename, "inNtuple");   
	nn =my_tuple->GetNvar();
	lrows = my_tuple->GetEntries();
	Float_t* row_content = new Float_t[nn];
	printf("\nTen rows of the full table of Ntuple\n %s\t%s\n\n  var{0)\t  var(1)\n", ntuplefilename, ntuplename);
	for (irow=0;irow<lrows && irow<10;++irow){ 
    		my_tuple->GetEntry(irow);
  		row_content = my_tuple->GetArgs();
    		for(i=0; i<nn; i++) {
    			printf("%lg\t", row_content[i]);
    		}
		printf("\n");
	}
my_tuple->Print();
my_tuple->Show(0);
my_tuple->Show(1);
}
